import { AmqpConnection } from '@golevelup/nestjs-rabbitmq';
import { Injectable } from '@nestjs/common';
import { ConfigService } from '@nestjs/config';
import { IMessageUser } from '../../domain/interfaces/user-messager';

@Injectable()
export class UserMessager extends IMessageUser {
  constructor(
    private readonly _configService: ConfigService,
    private readonly _amqpConnection: AmqpConnection,
  ) {
    super(_configService.get<string>('RMQ_EXCHANGE_NAME'));
  }

  publish(routingKey: string, message: string): void {
    this._amqpConnection.publish(this.exchange, routingKey, message);
  }
}
